/*
 * Copyright (c) 2010-2011, The MiCode Open Source Community (www.micode.net)
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *        http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
                                                                    //许可证的声明
package net.micode.notes.ui; //引入tools包

import android.content.Context; //第19到31行导入各种类
import android.database.Cursor; // 光标
import android.util.Log;
import android.view.View;
import android.view.ViewGroup;
import android.widget.CursorAdapter;

import net.micode.notes.data.Notes;

import java.util.Collection; //实现便签的编辑
import java.util.HashMap;
import java.util.HashSet;
import java.util.Iterator;
                     //直译为便签表连接器，继承了CursorAdapter，它为cursor和ListView提供了连接的桥梁。所以NotesListAdapter实现的是鼠标和编辑便签链接的桥梁
                     //便签列表适配器，拓展功能为光标适配器
public class NotesListAdapter extends CursorAdapter { //继承了CursorAdapter
    private static final String TAG = "NotesListAdapter"; //设置标签字符常量
    private Context mContext; //便签上下文、环境
    private HashMap<Integer, Boolean> mSelectedIndex; //HashMap是一个散列表，储存键值对的映射关系
    private int mNotesCount; //便签数
    private boolean mChoiceMode; //选择模式标志
                                           //桌面widget的属性，其中包括编号和类型
    public static class AppWidgetAttribute { //widget的编号和类型
        public int widgetId; //初始化便签链接器
        public int widgetType;
    }; //父类对象置空
                                           //功能描述：初始化NotesListAdapter实例，  函数实现：以便签列表的context初始化便签列表配适器
    public NotesListAdapter(Context context) { //初始化便签链接
        super(context, null); //功能描述：NoteListAdapter的构造函数 函数实现：继承父类函数；设置HashMap的map表，实现选择item与是否选择的键值对；设置context上下文；初始化note数量为0
        mSelectedIndex = new HashMap<Integer, Boolean>(); //新建HASH表
        mContext = context; //新建一个视图来存储光标所指向的数据
        mNotesCount = 0; //初始便签数为0
    } 
                                                   //功能描述：返回一个NotesListItem对象  函数实现：调用对象的构造方法，动态分配空间  参数描述：@context 内容存储器@cursor 光标对象@parent 父视图@return view 视图对象
    @Override //通过新建一个视图来存储光标所指向的数据
    public View newView(Context context, Cursor cursor, ViewGroup parent) {
        return new NotesListItem(context);
    }

    @Override
    public void bindView(View view, Context context, Cursor cursor) { //利用NotesListLtem类创建新布局
        if (view instanceof NotesListItem) { //创建便签列表的数据项
            NoteItemData itemData = new NoteItemData(context, cursor); //新建一个项目选项并且用bind跟将view和鼠标，内容，便签数据捆绑在一起
            ((NotesListItem) view).bind(context, itemData, mChoiceMode, //用光标指向的内容新建项目并将数据、项目、鼠标、视图捆绑起来
                    isSelectedItem(cursor.getPosition()));
        } //新建一个项目选项，然后用bind函数将视图跟鼠标，内容，便签相关数据捆绑在一起
    }
                                                  //设置勾选项
    public void setCheckedItem(final int position, final boolean checked) { //设置勾选框
        mSelectedIndex.put(position, checked); //根据定位和是否勾选设置下标
        notifyDataSetChanged(); //在修改后刷新activity
    }
                                                       //判断单选按钮是否勾选
    public boolean isInChoiceMode() { //判断单选按钮是否勾选
        return mChoiceMode; //设置单项选项框
    }
                                                    //设置单项选项框
    public void setChoiceMode(boolean mode) { //重置下标，并根据参数mode设置选项
        mSelectedIndex.clear(); //清空勾选下表并根据当前mode设置
        mChoiceMode = mode; 
    }
                                             //选择全部选项
    public void selectAll(boolean checked) { //设置全部勾选
        Cursor cursor = getCursor(); //获取光标位置
        for (int i = 0; i < getCount(); i++) { //遍历可用光标位置，如果光标移动且光标当前指向的便签项目类型为TYPE_NOTE则设置为勾选状态
            if (cursor.moveToPosition(i)) { //遍历所有位置并设置勾选标志
                if (NoteItemData.getNoteType(cursor) == Notes.TYPE_NOTE) { //处于便签状态
                    setCheckedItem(i, checked); //将位置i标志为已勾选加入到 mSelectedIndex中
                } //遍历所有的光标可用的位置，再判断便签类型后勾选单项框
            }
        }
    }
                              //创建选择项的下标列表
    public HashSet<Long> getSelectedItemIds() { //建立选择项目的ID的HASH表
        HashSet<Long> itemSet = new HashSet<Long>(); //建立hash表
        for (Integer position : mSelectedIndex.keySet()) { //遍历所有的关键
            if (mSelectedIndex.get(position) == true) { //判断光标位置是否可用
                Long id = getItemId(position);
                if (id == Notes.ID_ROOT_FOLDER) { //原文件不需添加
                    Log.d(TAG, "Wrong item id, should not happen"); //错误Id，不可添加
                } else { //如果不是，则加入条目集合
                    itemSet.add(id); //将该id加入到选项集合当中
                } //将id该下标假如选项集合中
            }
        }

        return itemSet; //返回条目集合
    }
                                                    //功能描述：以哈希表形式返回选中的桌面挂件  函数实现：同getSelectedItemIds 参数描述：@return 桌面挂件的集合
    public HashSet<AppWidgetAttribute> getSelectedWidget() { //建立桌面widget选项表
        HashSet<AppWidgetAttribute> itemSet = new HashSet<AppWidgetAttribute>(); //类似于getselecteditemids的实现方法
        for (Integer position : mSelectedIndex.keySet()) { //遍历被选中的列表
            if (mSelectedIndex.get(position) == true) {
                Cursor c = (Cursor) getItem(position); //用c记录光标位置以判断是否选择了桌面挂件（可用）
                if (c != null) { //获取光标位置可用
                    AppWidgetAttribute widget = new AppWidgetAttribute(); //新建widget并更新ID和类型，最后添加到选项表中
                    NoteItemData item = new NoteItemData(mContext, c); //初始化所选桌面挂件信息加入到itemSet中
                    widget.widgetId = item.getWidgetId();
                    widget.widgetType = item.getWidgetType();
                    itemSet.add(widget); //加入条目集合
                    /**
                     * Don't close cursor here, only the adapter could close it
                     */
                } else { //在这里，不关闭光标，而是在adapter中才能关闭光标
                    Log.e(TAG, "Invalid cursor"); //设置标签，无效的cursor
                    return null;
                }
            }
        }
        return itemSet;
    }
                                             //获取选项个数
    public int getSelectedCount() { //获取选项个数
        Collection<Boolean> values = mSelectedIndex.values(); //获取下标的值
        if (null == values) {  //如果此项值为空贼返回0
            return 0;
        }
        Iterator<Boolean> iter = values.iterator(); //初始化迭代器
        int count = 0;
        while (iter.hasNext()) { //循环计算选中便签的数目
            if (true == iter.next()) { //value值为真则count加一
                count++;
            }
        }
        return count;
    }
                           //判断是否全部选中
    public boolean isAllSelected() { //函数判断是否是全选
        int checkedCount = getSelectedCount(); //通过获得计数的结果与小米便签中的数量相比较
        return (checkedCount != 0 && checkedCount == mNotesCount); //对比选项数和总数是否一致且不为0
    }
                                        //判断是否为选项表
    public boolean isSelectedItem(final int position) { //通过下标来判断是否为选项表
        if (null == mSelectedIndex.get(position)) { //如果下标为空则返回false
            return false;
        }
        return mSelectedIndex.get(position); //判断Item是否被选中的状态
    }

    @Override
    protected void onContentChanged() { //如果便签的内容发生改变就要重新计算一下 便签的数量
        super.onContentChanged(); //执行父类函数
        calcNotesCount();
    }

    @Override //在activity光标发生局部变化时回调该函数计算便签的数量
    public void changeCursor(Cursor cursor) { // 光标变动时重新计算便签数量
        super.changeCursor(cursor); //重载父类函数
        calcNotesCount(); //calcNotesCount函数实现
    }
                        // 计算便签数量
    private void calcNotesCount() { //实现方式类似前面代码中的selectAll函数
        mNotesCount = 0;
        for (int i = 0; i < getCount(); i++) { //获取总数同时遍历
            Cursor c = (Cursor) getItem(i); //遍历所有选项
            if (c != null) { //判断语句，如果光标不是null，那么便得到信息，便签数目加1
                if (NoteItemData.getNoteType(c) == Notes.TYPE_NOTE) { //若选项的数据类型为便签类型，那么计数+1
                    mNotesCount++;
                }
            } else { //设置为无效的光标
                Log.e(TAG, "Invalid cursor"); //日志记录，将错误：无效光标事件记录到日志中去
                return; //否则就将设为无效光标
            }
        }
    }
}
